#version 430 core
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec4 aOffset;
layout (location = 2) in vec4 aColor;


out vec4 ParticleColor;

uniform vec3 CameraRight_worldspace;
uniform vec3 CameraUp_worldspace;
uniform mat4 ViewProjMatrix; 

void main()
{
	float particleSize = aOffset.w;
	vec3 Center = aOffset.xyz;

	vec3 position = Center +  CameraRight_worldspace * aPos.x * particleSize + CameraUp_worldspace * aPos.y * particleSize;

	gl_Position = ViewProjMatrix * vec4(position, 1.0f);

	ParticleColor = aColor;
    
}