#version 430 core

layout (location = 0) in vec3 Pos;
layout (location = 1) in vec3 Normal;
layout (location = 2) in vec2 UV;



out VertexData {
	vec3 vs_Pos;
	vec3 vs_Normals;
	vec2 vs_UVs;
	vec4 vs_ShadowCoord;
} vert;

uniform mat4 ModelMatrix;
uniform mat4 ViewProjMatrix;

uniform mat4 ShadowVP;




void main()
{
	
	vert.vs_Pos = vec4(ModelMatrix*vec4(Pos, 1.0f)).xyz;
	vert.vs_Normals = normalize(mat3(ModelMatrix)*Normal);
	vert.vs_UVs = UV;
	vert.vs_ShadowCoord = ShadowVP * vec4(vert.vs_Pos, 1.0);
    gl_Position = ViewProjMatrix * ModelMatrix * vec4(Pos, 1.0);


}

